<!DOCTYPE html>
<html lang="en">
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0"/>
    <meta charset="utf-8"/>
    <title>API Documentation &raquo;\Matrix\Matrix</title>
    <meta name="author" content=""/>
    <meta name="description" content=""/>        <link href="../css/template.css" rel="stylesheet" media="all"/>        <!--[if lt IE 9]>
        <script src="https://html5shim.googlecode.com/svn/trunk/html5.js" type="text/javascript"></script>
        <![endif]-->
        <script src="../js/jquery-1.7.1.min.js" type="text/javascript"></script>
        <script src="../js/jquery-ui-1.8.2.custom.min.js" type="text/javascript"></script>
        <script src="../js/jquery.mousewheel.min.js" type="text/javascript"></script>
        <script src="../js/bootstrap.js" type="text/javascript"></script>
        <script src="../js/template.js" type="text/javascript"></script>
        <script src="../js/prettify/prettify.min.js" type="text/javascript"></script>        <link rel="shortcut icon" href="../img/favicon.ico"/>
        <link rel="apple-touch-icon" href="../img/apple-touch-icon.png"/>
        <link rel="apple-touch-icon" sizes="72x72" href="../img/apple-touch-icon-72x72.png"/>
        <link rel="apple-touch-icon" sizes="114x114" href="../img/apple-touch-icon-114x114.png"/></head>
<body>    <div class="navbar navbar-fixed-top">
        <div class="navbar-inner">
            <div class="container">
                <a class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
                    <span class="icon-bar"></span> <span class="icon-bar"></span>
                    <span class="icon-bar"></span> </a>
                <a class="brand" href="../index.html">API Documentation</a>

                <div class="nav-collapse">
                    <ul class="nav">
                        <li class="dropdown">
                            <a href="#api" class="dropdown-toggle" data-toggle="dropdown">
                                API Documentation <b class="caret"></b>
                            </a>
                            <ul class="dropdown-menu">                                    <li><a>Namespaces</a></li>                                    <li><a href="../namespaces/task_23.html">task_23</a></li>                                    <li><a href="../namespaces/task_18.html">task_18</a></li>                                    <li><a href="../namespaces/task_22.html">task_22</a></li>                                    <li><a href="../namespaces/Composer.html">Composer</a></li>                                    <li><a href="../namespaces/Matrix.html">Matrix</a></li>                                    <li><a href="../namespaces/Complex.html">Complex</a></li>                                    <li><a href="../namespaces/Psr.html">Psr</a></li>                                    <li><a href="../namespaces/PhpOffice.html">PhpOffice</a></li>                                    <li><a href="../namespaces/Samples.html">Samples</a></li>                                    <li><a href="../namespaces/task_21.html">task_21</a></li>                                    <li><a href="../namespaces/task_24.html">task_24</a></li>                                    <li><a href="../namespaces/task_20.html">task_20</a></li>                                    <li><a href="../namespaces/task_17.html">task_17</a></li>                                    <li><a href="../namespaces/task_19.html">task_19</a></li>                            </ul>
                        </li>
                        <li class="dropdown" id="charts-menu">
                            <a href="#charts" class="dropdown-toggle" data-toggle="dropdown">
                                Charts <b class="caret"></b>
                            </a>
                            <ul class="dropdown-menu">
                                <li>
                                    <a href="../graph_class.html">
                                        <i class="icon-list-alt"></i>&#160;Class hierarchy diagram
                                    </a>
                                </li>
                            </ul>
                        </li>
                        <li class="dropdown" id="reports-menu">
                            <a href="#reports" class="dropdown-toggle" data-toggle="dropdown">
                                Reports <b class="caret"></b>
                            </a>
                            <ul class="dropdown-menu">
                                <li>
                                    <a href="../errors.html">
                                        <i class="icon-list-alt"></i>&#160;Errors
                                    </a>
                                </li>
                                <li>
                                    <a href="../markers.html">
                                        <i class="icon-list-alt"></i>&#160;Markers
                                    </a>
                                </li>
                                <li>
                                    <a href="../deprecated.html">
                                        <i class="icon-list-alt"></i>&#160;Deprecated
                                    </a>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
        <div class="go_to_top">
            <a href="#___" style="color: inherit">Back to top&#160;&#160;<i class="icon-upload icon-white"></i></a>
        </div>
    </div>
    <div id="___" class="container">
        <noscript>
            <div class="alert alert-warning">
                Javascript is disabled; several features are only available if Javascript is enabled.
            </div>
        </noscript>    <style>
        .deprecated h2 {
            text-decoration: line-through;
        }
    </style>
    <div class="row">
        <div class="span4">    <div class="btn-group view pull-right" data-toggle="buttons-radio">
        <button class="btn details" title="Show descriptions and method names"><i class="icon-list"></i></button>
        <button class="btn simple" title="Show only method names"><i class="icon-align-justify"></i></button>
    </div>
    <div class="btn-group visibility" data-toggle="buttons-checkbox">
        <button class="btn public active" title="Show public elements">Public</button>
        <button class="btn protected" title="Show protected elements">Protected</button>
        <button class="btn private" title="Show private elements">Private</button>
        <button class="btn inherited active" title="Show inherited elements">Inherited</button>
    </div>    <ul class="side-nav nav nav-list">
        <li class="nav-header">
            <i class="icon-custom icon-method"></i> Methods
            <ul>    <li class="methodpublic">
        <a href="#method___call" title="__call ::Returns the result of the function call or operation">
            <span class="description">Returns the result of the function call or operation</span><pre>__call</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method___construct" title="__construct ::">
            <span class="description"></span><pre>__construct</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method___get" title="__get ::Access specific properties as read-only (no setters)">
            <span class="description">Access specific properties as read-only (no setters)</span><pre>__get</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_add" title="add ::">
            <span class="description"></span><pre>add</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_adjoint" title="adjoint ::">
            <span class="description"></span><pre>adjoint</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_antidiagonal" title="antidiagonal ::">
            <span class="description"></span><pre>antidiagonal</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_cofactors" title="cofactors ::">
            <span class="description"></span><pre>cofactors</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_columns" title="columns ::Returns a Generator that will yield each column of the matrix in turn as a vector matrix
    or the value of each cell if the matrix is a vector">
            <span class="description">Returns a Generator that will yield each column of the matrix in turn as a vector matrix
    or the value of each cell if the matrix is a vector</span><pre>columns</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_determinant" title="determinant ::">
            <span class="description"></span><pre>determinant</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_diagonal" title="diagonal ::">
            <span class="description"></span><pre>diagonal</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_divideby" title="divideby ::">
            <span class="description"></span><pre>divideby</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_divideinto" title="divideinto ::">
            <span class="description"></span><pre>divideinto</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_dropColumns" title="dropColumns ::Return a new matrix as a subset of columns from this matrix, dropping columns starting at column number $column,
    and $columnCount columns
A negative $columnCount value will drop columns until that many columns from the end of the matrix
A $columnCount value of 0 will remove all columns of the matrix from $column">
            <span class="description">Return a new matrix as a subset of columns from this matrix, dropping columns starting at column number $column,
    and $columnCount columns
A negative $columnCount value will drop columns until that many columns from the end of the matrix
A $columnCount value of 0 will remove all columns of the matrix from $column</span><pre>dropColumns</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_dropRows" title="dropRows ::Return a new matrix as a subset of rows from this matrix, dropping rows starting at row number $row,
    and $rowCount rows
A negative $rowCount value will drop rows until that many rows from the end of the matrix
A $rowCount value of 0 will remove all rows of the matrix from $row">
            <span class="description">Return a new matrix as a subset of rows from this matrix, dropping rows starting at row number $row,
    and $rowCount rows
A negative $rowCount value will drop rows until that many rows from the end of the matrix
A $rowCount value of 0 will remove all rows of the matrix from $row</span><pre>dropRows</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getColumns" title="getColumns ::Return a new matrix as a subset of columns from this matrix, starting at column number $column, and $columnCount columns
A $columnCount value of 0 will return all columns of the matrix from $column
A negative $columnCount value will return columns until that many columns from the end of the matrix">
            <span class="description">Return a new matrix as a subset of columns from this matrix, starting at column number $column, and $columnCount columns
A $columnCount value of 0 will return all columns of the matrix from $column
A negative $columnCount value will return columns until that many columns from the end of the matrix</span><pre>getColumns</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getRows" title="getRows ::Return a new matrix as a subset of rows from this matrix, starting at row number $row, and $rowCount rows
A $rowCount value of 0 will return all rows of the matrix from $row
A negative $rowCount value will return rows until that many rows from the end of the matrix">
            <span class="description">Return a new matrix as a subset of rows from this matrix, starting at row number $row, and $rowCount rows
A $rowCount value of 0 will return all rows of the matrix from $row
A negative $rowCount value will return rows until that many rows from the end of the matrix</span><pre>getRows</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getValue" title="getValue ::Return a value from this matrix, from the &quot;cell&quot; identified by the row and column numbers
Note that row and column numbers start from 1, not from 0">
            <span class="description">Return a value from this matrix, from the &quot;cell&quot; identified by the row and column numbers
Note that row and column numbers start from 1, not from 0</span><pre>getValue</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_identity" title="identity ::">
            <span class="description"></span><pre>identity</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_inverse" title="inverse ::">
            <span class="description"></span><pre>inverse</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_isSquare" title="isSquare ::Identify if the row and column dimensions of this matrix are equal,
    i.e. if it is a &quot;square&quot; matrix">
            <span class="description">Identify if the row and column dimensions of this matrix are equal,
    i.e. if it is a &quot;square&quot; matrix</span><pre>isSquare</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_isVector" title="isVector ::Identify if this matrix is a vector
    i.e. if it comprises only a single row or a single column">
            <span class="description">Identify if this matrix is a vector
    i.e. if it comprises only a single row or a single column</span><pre>isVector</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_minors" title="minors ::">
            <span class="description"></span><pre>minors</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_multiply" title="multiply ::">
            <span class="description"></span><pre>multiply</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_pseudoInverse" title="pseudoInverse ::">
            <span class="description"></span><pre>pseudoInverse</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_rows" title="rows ::Returns a Generator that will yield each row of the matrix in turn as a vector matrix
    or the value of each cell if the matrix is a vector">
            <span class="description">Returns a Generator that will yield each row of the matrix in turn as a vector matrix
    or the value of each cell if the matrix is a vector</span><pre>rows</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_subtract" title="subtract ::">
            <span class="description"></span><pre>subtract</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_toArray" title="toArray ::Return the matrix as a 2-dimensional array">
            <span class="description">Return the matrix as a 2-dimensional array</span><pre>toArray</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_trace" title="trace ::">
            <span class="description"></span><pre>trace</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_transpose" title="transpose ::">
            <span class="description"></span><pre>transpose</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_validateColumn" title="validateColumn ::Validate that a column number is a positive integer">
            <span class="description">Validate that a column number is a positive integer</span><pre>validateColumn</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_validateRow" title="validateRow ::Validate that a row number is a positive integer">
            <span class="description">Validate that a row number is a positive integer</span><pre>validateRow</pre>
        </a>
    </li>            </ul>
        </li>
        <li class="nav-header protected">» Protected
            <ul>                        <li class="methodprotected">
                            <a href="#method_buildFromArray" title="buildFromArray ::">
                                <span class="description"></span><pre>buildFromArray</pre>
                            </a>
                        </li>                        <li class="methodprotected">
                            <a href="#method_validateColumnInRange" title="validateColumnInRange ::Validate that a column number falls within the set of columns for this matrix">
                                <span class="description">Validate that a column number falls within the set of columns for this matrix</span><pre>validateColumnInRange</pre>
                            </a>
                        </li>                        <li class="methodprotected">
                            <a href="#method_validateRowInRange" title="validateRowInRange ::Validate that a row number falls within the set of rows for this matrix">
                                <span class="description">Validate that a row number falls within the set of rows for this matrix</span><pre>validateRowInRange</pre>
                            </a>
                        </li>            </ul>
        </li>
        <li class="nav-header private">» Private
            <ul>            </ul>
        </li>
        <li class="nav-header">
            <i class="icon-custom icon-constant"></i> Constants
            <ul>            </ul>
        </li>
    </ul>
        </div>

        <div class="span8">
            <div class="element class">
                <h1>Matrix</h1>
                <small style="display: block; text-align: right">                </small>
                <p class="short_description">Matrix object.</p>
                <div class="details">
                    <div class="long_description">
                    </div>
                    <table class="table table-bordered">                                <tr>
                                    <th>package                                    </th>
                                    <td><p>Matrix</p>
                                    </td>
                                </tr>                                <tr>
                                    <th>property-read                                    </th>
                                    <td><p>The number of rows in the matrix</p>
                                    </td>
                                </tr>                                <tr>
                                    <th>property-read                                    </th>
                                    <td><p>The number of columns in the matrix</p>
                                    </td>
                                </tr>                    </table>

                    <h3><i class="icon-custom icon-method"></i> Methods</h3>                        <a id="method___call"></a>
                        <div class="element clickable methodpublic method___call" data-toggle="collapse" data-target=".method___call .collapse">
                            <h2>Returns the result of the function call or operation</h2>
                            <pre>__call(string $functionName,array&lt;mixed,mixed&gt; $arguments): \Matrix\Matrix|float</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>Throws</th>
                                                <td>
                                                    <dl>                                                        <dt>\Matrix\Exception</dt>
                                                        <dd></dd>                                                    </dl>
                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$functionName</h4>
                                                <code>string</code><p></p>
                                            </div>                                            <div class="subelement argument">
                                                <h4>$arguments</h4>
                                                <code>array&lt;mixed,mixed&gt;</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code><a href="../classes/Matrix.Matrix.html">\Matrix\Matrix</a>|float</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method___construct"></a>
                        <div class="element clickable methodpublic method___construct" data-toggle="collapse" data-target=".method___construct .collapse">
                            <h2>__construct</h2>
                            <pre>__construct(array $grid)</pre>
                            <div class="labels"><span class="label">final</span>                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$grid</h4>
                                                <code>array</code><p></p>
                                            </div>                                </div>
                            </div>

                        </div>                        <a id="method___get"></a>
                        <div class="element clickable methodpublic method___get" data-toggle="collapse" data-target=".method___get .collapse">
                            <h2>Access specific properties as read-only (no setters)</h2>
                            <pre>__get(string $propertyName): mixed</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>Throws</th>
                                                <td>
                                                    <dl>                                                        <dt>\Matrix\Exception</dt>
                                                        <dd></dd>                                                    </dl>
                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$propertyName</h4>
                                                <code>string</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>mixed</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_add"></a>
                        <div class="element clickable methodpublic method_add" data-toggle="collapse" data-target=".method_add .collapse">
                            <h2>add</h2>
                            <pre>add(mixed $...$matrices): \Matrix\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$...$matrices</h4>
                                                <code>mixed</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>\Matrix\Matrix</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_adjoint"></a>
                        <div class="element clickable methodpublic method_adjoint" data-toggle="collapse" data-target=".method_adjoint .collapse">
                            <h2>adjoint</h2>
                            <pre>adjoint(): \Matrix\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Response</h3>
                                        <code>\Matrix\Matrix</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_antidiagonal"></a>
                        <div class="element clickable methodpublic method_antidiagonal" data-toggle="collapse" data-target=".method_antidiagonal .collapse">
                            <h2>antidiagonal</h2>
                            <pre>antidiagonal(): \Matrix\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Response</h3>
                                        <code>\Matrix\Matrix</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_buildFromArray"></a>
                        <div class="element clickable methodprotected method_buildFromArray" data-toggle="collapse" data-target=".method_buildFromArray .collapse">
                            <h2>buildFromArray</h2>
                            <pre>buildFromArray(array $grid)</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$grid</h4>
                                                <code>array</code><p></p>
                                            </div>                                </div>
                            </div>

                        </div>                        <a id="method_cofactors"></a>
                        <div class="element clickable methodpublic method_cofactors" data-toggle="collapse" data-target=".method_cofactors .collapse">
                            <h2>cofactors</h2>
                            <pre>cofactors(): \Matrix\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Response</h3>
                                        <code>\Matrix\Matrix</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_columns"></a>
                        <div class="element clickable methodpublic method_columns" data-toggle="collapse" data-target=".method_columns .collapse">
                            <h2>Returns a Generator that will yield each column of the matrix in turn as a vector matrix
    or the value of each cell if the matrix is a vector</h2>
                            <pre>columns(): \Generator|array&lt;mixed,\Matrix\Matrix&gt;|array&lt;mixed,mixed&gt;</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>\Generator|array&lt;mixed,<a href="../classes/Matrix.Matrix.html">\Matrix\Matrix</a>&gt;|array&lt;mixed,mixed&gt;</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_determinant"></a>
                        <div class="element clickable methodpublic method_determinant" data-toggle="collapse" data-target=".method_determinant .collapse">
                            <h2>determinant</h2>
                            <pre>determinant(): float</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Response</h3>
                                        <code>float</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_diagonal"></a>
                        <div class="element clickable methodpublic method_diagonal" data-toggle="collapse" data-target=".method_diagonal .collapse">
                            <h2>diagonal</h2>
                            <pre>diagonal(): \Matrix\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Response</h3>
                                        <code>\Matrix\Matrix</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_divideby"></a>
                        <div class="element clickable methodpublic method_divideby" data-toggle="collapse" data-target=".method_divideby .collapse">
                            <h2>divideby</h2>
                            <pre>divideby(mixed $...$matrices): \Matrix\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$...$matrices</h4>
                                                <code>mixed</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>\Matrix\Matrix</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_divideinto"></a>
                        <div class="element clickable methodpublic method_divideinto" data-toggle="collapse" data-target=".method_divideinto .collapse">
                            <h2>divideinto</h2>
                            <pre>divideinto(mixed $...$matrices): \Matrix\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$...$matrices</h4>
                                                <code>mixed</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>\Matrix\Matrix</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_dropColumns"></a>
                        <div class="element clickable methodpublic method_dropColumns" data-toggle="collapse" data-target=".method_dropColumns .collapse">
                            <h2>Return a new matrix as a subset of columns from this matrix, dropping columns starting at column number $column,
    and $columnCount columns
A negative $columnCount value will drop columns until that many columns from the end of the matrix
A $columnCount value of 0 will remove all columns of the matrix from $column</h2>
                            <pre>dropColumns(integer $column,integer $columnCount = 1): static</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"><p>Note that column numbers start from 1, not from 0</p></div>

                                    <table class="table">                                            <tr>
                                                <th>Throws</th>
                                                <td>
                                                    <dl>                                                        <dt>\Matrix\Exception</dt>
                                                        <dd></dd>                                                    </dl>
                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$column</h4>
                                                <code>integer</code><p></p>
                                            </div>                                            <div class="subelement argument">
                                                <h4>$columnCount</h4>
                                                <code>integer</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>static</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_dropRows"></a>
                        <div class="element clickable methodpublic method_dropRows" data-toggle="collapse" data-target=".method_dropRows .collapse">
                            <h2>Return a new matrix as a subset of rows from this matrix, dropping rows starting at row number $row,
    and $rowCount rows
A negative $rowCount value will drop rows until that many rows from the end of the matrix
A $rowCount value of 0 will remove all rows of the matrix from $row</h2>
                            <pre>dropRows(integer $row,integer $rowCount = 1): static</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"><p>Note that row numbers start from 1, not from 0</p></div>

                                    <table class="table">                                            <tr>
                                                <th>Throws</th>
                                                <td>
                                                    <dl>                                                        <dt>\Matrix\Exception</dt>
                                                        <dd></dd>                                                    </dl>
                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$row</h4>
                                                <code>integer</code><p></p>
                                            </div>                                            <div class="subelement argument">
                                                <h4>$rowCount</h4>
                                                <code>integer</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>static</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_getColumns"></a>
                        <div class="element clickable methodpublic method_getColumns" data-toggle="collapse" data-target=".method_getColumns .collapse">
                            <h2>Return a new matrix as a subset of columns from this matrix, starting at column number $column, and $columnCount columns
A $columnCount value of 0 will return all columns of the matrix from $column
A negative $columnCount value will return columns until that many columns from the end of the matrix</h2>
                            <pre>getColumns(integer $column,integer $columnCount = 1): \Matrix\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"><p>Note that column numbers start from 1, not from 0</p></div>

                                    <table class="table">                                            <tr>
                                                <th>Throws</th>
                                                <td>
                                                    <dl>                                                        <dt>\Matrix\Exception</dt>
                                                        <dd></dd>                                                    </dl>
                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$column</h4>
                                                <code>integer</code><p></p>
                                            </div>                                            <div class="subelement argument">
                                                <h4>$columnCount</h4>
                                                <code>integer</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code><a href="../classes/Matrix.Matrix.html">\Matrix\Matrix</a></code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_getRows"></a>
                        <div class="element clickable methodpublic method_getRows" data-toggle="collapse" data-target=".method_getRows .collapse">
                            <h2>Return a new matrix as a subset of rows from this matrix, starting at row number $row, and $rowCount rows
A $rowCount value of 0 will return all rows of the matrix from $row
A negative $rowCount value will return rows until that many rows from the end of the matrix</h2>
                            <pre>getRows(integer $row,integer $rowCount = 1): static</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"><p>Note that row numbers start from 1, not from 0</p></div>

                                    <table class="table">                                            <tr>
                                                <th>Throws</th>
                                                <td>
                                                    <dl>                                                        <dt>\Matrix\Exception</dt>
                                                        <dd></dd>                                                    </dl>
                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$row</h4>
                                                <code>integer</code><p></p>
                                            </div>                                            <div class="subelement argument">
                                                <h4>$rowCount</h4>
                                                <code>integer</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>static</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_getValue"></a>
                        <div class="element clickable methodpublic method_getValue" data-toggle="collapse" data-target=".method_getValue .collapse">
                            <h2>Return a value from this matrix, from the &quot;cell&quot; identified by the row and column numbers
Note that row and column numbers start from 1, not from 0</h2>
                            <pre>getValue(integer $row,integer $column): mixed</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>Throws</th>
                                                <td>
                                                    <dl>                                                        <dt>\Matrix\Exception</dt>
                                                        <dd></dd>                                                    </dl>
                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$row</h4>
                                                <code>integer</code><p></p>
                                            </div>                                            <div class="subelement argument">
                                                <h4>$column</h4>
                                                <code>integer</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>mixed</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_identity"></a>
                        <div class="element clickable methodpublic method_identity" data-toggle="collapse" data-target=".method_identity .collapse">
                            <h2>identity</h2>
                            <pre>identity(): \Matrix\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Response</h3>
                                        <code>\Matrix\Matrix</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_inverse"></a>
                        <div class="element clickable methodpublic method_inverse" data-toggle="collapse" data-target=".method_inverse .collapse">
                            <h2>inverse</h2>
                            <pre>inverse(): \Matrix\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Response</h3>
                                        <code>\Matrix\Matrix</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_isSquare"></a>
                        <div class="element clickable methodpublic method_isSquare" data-toggle="collapse" data-target=".method_isSquare .collapse">
                            <h2>Identify if the row and column dimensions of this matrix are equal,
    i.e. if it is a &quot;square&quot; matrix</h2>
                            <pre>isSquare(): boolean</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>boolean</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_isVector"></a>
                        <div class="element clickable methodpublic method_isVector" data-toggle="collapse" data-target=".method_isVector .collapse">
                            <h2>Identify if this matrix is a vector
    i.e. if it comprises only a single row or a single column</h2>
                            <pre>isVector(): boolean</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>boolean</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_minors"></a>
                        <div class="element clickable methodpublic method_minors" data-toggle="collapse" data-target=".method_minors .collapse">
                            <h2>minors</h2>
                            <pre>minors(): \Matrix\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Response</h3>
                                        <code>\Matrix\Matrix</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_multiply"></a>
                        <div class="element clickable methodpublic method_multiply" data-toggle="collapse" data-target=".method_multiply .collapse">
                            <h2>multiply</h2>
                            <pre>multiply(mixed $...$matrices): \Matrix\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$...$matrices</h4>
                                                <code>mixed</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>\Matrix\Matrix</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_pseudoInverse"></a>
                        <div class="element clickable methodpublic method_pseudoInverse" data-toggle="collapse" data-target=".method_pseudoInverse .collapse">
                            <h2>pseudoInverse</h2>
                            <pre>pseudoInverse(): \Matrix\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Response</h3>
                                        <code>\Matrix\Matrix</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_rows"></a>
                        <div class="element clickable methodpublic method_rows" data-toggle="collapse" data-target=".method_rows .collapse">
                            <h2>Returns a Generator that will yield each row of the matrix in turn as a vector matrix
    or the value of each cell if the matrix is a vector</h2>
                            <pre>rows(): \Generator|array&lt;mixed,\Matrix\Matrix&gt;|array&lt;mixed,mixed&gt;</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>\Generator|array&lt;mixed,<a href="../classes/Matrix.Matrix.html">\Matrix\Matrix</a>&gt;|array&lt;mixed,mixed&gt;</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_subtract"></a>
                        <div class="element clickable methodpublic method_subtract" data-toggle="collapse" data-target=".method_subtract .collapse">
                            <h2>subtract</h2>
                            <pre>subtract(mixed $...$matrices): \Matrix\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$...$matrices</h4>
                                                <code>mixed</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>\Matrix\Matrix</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_toArray"></a>
                        <div class="element clickable methodpublic method_toArray" data-toggle="collapse" data-target=".method_toArray .collapse">
                            <h2>Return the matrix as a 2-dimensional array</h2>
                            <pre>toArray(): array</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>array</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_trace"></a>
                        <div class="element clickable methodpublic method_trace" data-toggle="collapse" data-target=".method_trace .collapse">
                            <h2>trace</h2>
                            <pre>trace(): float</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Response</h3>
                                        <code>float</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_transpose"></a>
                        <div class="element clickable methodpublic method_transpose" data-toggle="collapse" data-target=".method_transpose .collapse">
                            <h2>transpose</h2>
                            <pre>transpose(): \Matrix\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Response</h3>
                                        <code>\Matrix\Matrix</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_validateColumn"></a>
                        <div class="element clickable methodpublic method_validateColumn" data-toggle="collapse" data-target=".method_validateColumn .collapse">
                            <h2>Validate that a column number is a positive integer</h2>
                            <pre>validateColumn(integer $column): integer</pre>
                            <div class="labels"><span class="label">static</span>                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>Throws</th>
                                                <td>
                                                    <dl>                                                        <dt>\Matrix\Exception</dt>
                                                        <dd></dd>                                                    </dl>
                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$column</h4>
                                                <code>integer</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>integer</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_validateColumnInRange"></a>
                        <div class="element clickable methodprotected method_validateColumnInRange" data-toggle="collapse" data-target=".method_validateColumnInRange .collapse">
                            <h2>Validate that a column number falls within the set of columns for this matrix</h2>
                            <pre>validateColumnInRange(integer $column): integer</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>Throws</th>
                                                <td>
                                                    <dl>                                                        <dt>\Matrix\Exception</dt>
                                                        <dd></dd>                                                    </dl>
                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$column</h4>
                                                <code>integer</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>integer</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_validateRow"></a>
                        <div class="element clickable methodpublic method_validateRow" data-toggle="collapse" data-target=".method_validateRow .collapse">
                            <h2>Validate that a row number is a positive integer</h2>
                            <pre>validateRow(integer $row): integer</pre>
                            <div class="labels"><span class="label">static</span>                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>Throws</th>
                                                <td>
                                                    <dl>                                                        <dt>\Matrix\Exception</dt>
                                                        <dd></dd>                                                    </dl>
                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$row</h4>
                                                <code>integer</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>integer</code><p></p>                                </div>
                            </div>

                        </div>                        <a id="method_validateRowInRange"></a>
                        <div class="element clickable methodprotected method_validateRowInRange" data-toggle="collapse" data-target=".method_validateRowInRange .collapse">
                            <h2>Validate that a row number falls within the set of rows for this matrix</h2>
                            <pre>validateRowInRange(integer $row): integer</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>Throws</th>
                                                <td>
                                                    <dl>                                                        <dt>\Matrix\Exception</dt>
                                                        <dd></dd>                                                    </dl>
                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$row</h4>
                                                <code>integer</code><p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>integer</code><p></p>                                </div>
                            </div>

                        </div>                        <h3><i class="icon-custom icon-property"></i> Properties</h3>                            <a id="property_rows"> </a>
                            <div class="element clickable propertyprotected property_rows" data-toggle="collapse" data-target=".property_rows .collapse">
                                <h2>rows</h2>
                                <pre>rows :</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code></code>                                    </div>
                                </div>
                            </div>                            <a id="property_columns"> </a>
                            <div class="element clickable propertyprotected property_columns" data-toggle="collapse" data-target=".property_columns .collapse">
                                <h2>columns</h2>
                                <pre>columns :</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code></code>                                    </div>
                                </div>
                            </div>                            <a id="property_grid"> </a>
                            <div class="element clickable propertyprotected property_grid" data-toggle="collapse" data-target=".property_grid .collapse">
                                <h2>grid</h2>
                                <pre>grid :</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code></code>                                    </div>
                                </div>
                            </div>                            <a id="property_getters"> </a>
                            <div class="element clickable propertyprotected property_getters" data-toggle="collapse" data-target=".property_getters .collapse">
                                <h2>getters</h2>
                                <pre>getters :</pre>
                                <div class="labels"><span class="label">static</span>                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code></code>                                    </div>
                                </div>
                            </div>                            <a id="property_functions"> </a>
                            <div class="element clickable propertyprotected property_functions" data-toggle="collapse" data-target=".property_functions .collapse">
                                <h2>functions</h2>
                                <pre>functions :</pre>
                                <div class="labels"><span class="label">static</span>                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code></code>                                    </div>
                                </div>
                            </div>                            <a id="property_operations"> </a>
                            <div class="element clickable propertyprotected property_operations" data-toggle="collapse" data-target=".property_operations .collapse">
                                <h2>operations</h2>
                                <pre>operations :</pre>
                                <div class="labels"><span class="label">static</span>                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code></code>                                    </div>
                                </div>
                            </div>                            <a id="property_rows"> </a>
                            <div class="element clickable propertypublic property_rows" data-toggle="collapse" data-target=".property_rows .collapse">
                                <h2>rows</h2>
                                <pre>rows :integer</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"><p>The number of rows in the matrix</p></div>

                                        <table class="table">                                                <tr>
                                                    <th>
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>integer</code>                                    </div>
                                </div>
                            </div>                            <a id="property_columns"> </a>
                            <div class="element clickable propertypublic property_columns" data-toggle="collapse" data-target=".property_columns .collapse">
                                <h2>columns</h2>
                                <pre>columns :integer</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"><p>The number of columns in the matrix</p></div>

                                        <table class="table">                                                <tr>
                                                    <th>
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>integer</code>                                    </div>
                                </div>
                            </div>                </div>
            </div>
            <a id="\Matrix\Matrix"></a>
            <ul class="breadcrumb">
                <li><a href="../index.html"><i class="icon-custom icon-class"></i></a></li>
    <li><span class="divider">\</span><a href="../namespaces/Matrix.html">Matrix</a></li>
                <li class="active"><span class="divider">\</span><a href="../classes/Matrix.Matrix.html">Matrix</a></li>
            </ul>
        </div>
    </div>    </div>    <footer class="span12">
            Template is built using <a href="http://twitter.github.com/bootstrap/">Twitter Bootstrap 2</a> and icons provided by
            <a href="http://glyphicons.com/">Glyphicons</a>.<br/>
            Documentation is powered by <a href="http://www.phpdoc.org/">phpDocumentor</a> and<br/>
            generated onFri, 14 Feb 2020 19:36:44 +0000.<br/>
    </footer></body>
</html>
